Index: mapstorage.cc
===================================================================
--- mapstorage.cc	(revision 201)
+++ mapstorage.cc	(revision 184)
@@ -8,5 +8,5 @@
  *
  * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all cop	ies. For
+ * provided that this copyright notice appears in all copies. For
  * precise terms see the accompanying LICENSE file.
  *
@@ -17,51 +17,33 @@
  */
 
-#include "i18n.h"
+#include "mapstorage.h"
+#include "nbtab.h"
+#include "gui_writer.h"
+#include "gui_reader.h"
 #include <limits>
 #include <cmath>
-#include <iostream>
-#include <fstream>
-#include <string>
-#include <algorithm>
 #include <gtkmm.h>
-#include "file_import_dialog.h"
-#include <mapstorage.h>
-#include <gui_writer.h>
-#include <gui_reader.h>
-#include <lemon/graph_to_eps.h>
-
-const int i_d=20;
+
+const double i_d=20;
 const double a_d=0.05;
 const double p_d=40000;
 
-MapStorage::MapStorage() :
-  gui_sect_save_dest(LGF_FILE),
-  node_coords_save_dest(SpecMapSaveOpts::GUI_SECT),
-  arrow_coords_save_dest(SpecMapSaveOpts::GUI_SECT),
-  modified(false),
-  file_name(""),
-  max_node_label(0),
-  max_edge_label(0),
-  node_coords_one_map_name("coord"),
-  node_coords_two_maps_1_name("coord_x"),
-  node_coords_two_maps_2_name("coord_y"),
-  arrow_coords_one_map_name("arrow"),
-  arrow_coords_two_maps_1_name("arrow_x"),
-  arrow_coords_two_maps_2_name("arrow_y"),
-  iterations(i_d),
-  attraction(a_d),
-  propulsation(p_d),
-  node_coords_x(graph),
-  node_coords_y(graph),
-  arrow_coords_x(graph),
-  arrow_coords_y(graph),
-  node_label(graph),
-  edge_label(graph),
-  background_set(false)
-{
-  node_coords.setXMap(node_coords_x);
-  node_coords.setYMap(node_coords_y);
-  arrow_coords.setXMap(arrow_coords_x);
-  arrow_coords.setYMap(arrow_coords_y);
+MapStorage::MapStorage(NoteBookTab& tab) : mytab(tab), modified(false), file_name(""), arrow_pos_read_ok(false), iterations(i_d), attraction(a_d), propulsation(p_d), background_set(false)
+{
+  nodemap_storage["coordinates_x"] = new Graph::NodeMap<double>(graph);
+  coords.setXMap(*nodemap_storage["coordinates_x"]);
+  nodemap_storage["coordinates_y"] = new Graph::NodeMap<double>(graph);
+  coords.setYMap(*nodemap_storage["coordinates_y"]);
+
+  edgemap_storage["arrow_pos_x"] = new Graph::EdgeMap<double>(graph);
+  arrow_pos.setXMap(*edgemap_storage["arrow_pos_x"]);
+  edgemap_storage["arrow_pos_y"] = new Graph::EdgeMap<double>(graph);
+  arrow_pos.setYMap(*edgemap_storage["arrow_pos_y"]);
+
+  nodemap_storage["label"] = new Graph::NodeMap<double>(graph);
+  edgemap_storage["label"] = new Graph::EdgeMap<double>(graph);
+
+  nodemap_default["label"] = 1.0;
+  edgemap_default["label"] = 1.0;
 
   active_nodemaps.resize(NODE_PROPERTY_NUM);
@@ -80,49 +62,29 @@
 MapStorage::~MapStorage()
 {
-  clear();
-}
-
-void MapStorage::createNodeMap(const std::string& name, MapValue::Type type,
-    MapValue def_val)
-{
-  NodeMapStore::const_iterator it = nodemaps.find(name);
-  if (it != nodemaps.end())
-    throw Error("Node map " + name + " already exists.");
-
-  switch (type)
-  {
-    case MapValue::NUMERIC:
-      nodemaps[name] = new NumericNodeMapData(graph, def_val);
-      break;
-    case MapValue::STRING:
-      nodemaps[name] = new StringNodeMapData(graph, def_val);
-      break;
-  }
-
-  nodemaps[name]->default_value = def_val;
-
-  signal_node_map.emit(name, type);
-}
-
-void MapStorage::createEdgeMap(const std::string& name, MapValue::Type type,
-    MapValue def_val)
-{
-  EdgeMapStore::const_iterator it = edgemaps.find(name);
-  if (it != edgemaps.end())
-    throw Error("Edge map " + name + " already exists.");
-
-  switch (type)
-  {
-    case MapValue::NUMERIC:
-      edgemaps[name] = new NumericEdgeMapData(graph, def_val);
-      break;
-    case MapValue::STRING:
-      edgemaps[name] = new StringEdgeMapData(graph, def_val);
-      break;
-  }
-
-  edgemaps[name]->default_value = def_val;
-
-  signal_edge_map.emit(name, type);
+  for (std::map<std::string, Graph::NodeMap<double>*>::const_iterator it =
+      nodemap_storage.begin(); it != nodemap_storage.end(); ++it)
+  {
+    delete it->second;
+  }
+  for (std::map<std::string, Graph::EdgeMap<double>*>::const_iterator it =
+      edgemap_storage.begin(); it != edgemap_storage.end(); ++it)
+  {
+    delete it->second;
+  }
+}
+
+int MapStorage::addNodeMap(const std::string & name, Graph::NodeMap<double> *nodemap, double default_value)
+{
+  if( nodemap_storage.find(name) == nodemap_storage.end() )
+    {
+      nodemap_storage[name]=nodemap;
+      // set the maps default value
+      nodemap_default[name] = default_value;
+
+      //announce changement in maps
+      signal_node_map.emit(name);
+      return 0;
+    }
+  return 1;
 }
 
@@ -153,4 +115,5 @@
 }
 
+
 std::string MapStorage::getActiveEdgeMap(int prop)
 {
@@ -163,554 +126,286 @@
 }
 
-std::vector<std::string> MapStorage::getEdgeMapList(MapType type)
-{
-  if (type == ALL)
-  {
-    std::vector<std::string> ret;
-    for (EdgeMapStore::const_iterator it = edgemaps.begin();
-        it != edgemaps.end(); ++it)
-    {
-      ret.push_back(it->first);
-    }
-    return ret;
-  }
+std::vector<std::string> MapStorage::getEdgeMapList()
+{
+  std::vector<std::string> eml;
+  eml.resize(edgemap_storage.size());
+  int i=0;
+  std::map< std::string,Graph::EdgeMap<double> * >::iterator emsi=beginOfEdgeMaps();
+  for(;emsi!=endOfEdgeMaps();emsi++)
+    {
+      eml[i]=(emsi->first);
+      i++;
+    }
+  return eml;
+}
+
+std::vector<std::string> MapStorage::getNodeMapList()
+{
+  std::vector<std::string> nml;
+  nml.resize(nodemap_storage.size());
+  int i=0;
+  std::map< std::string,Graph::NodeMap<double> * >::iterator nmsi=beginOfNodeMaps();
+  for(;nmsi!=endOfNodeMaps();nmsi++)
+    {
+      nml[i]=(nmsi->first);
+      i++;
+    }
+  return nml;
+}
+
+sigc::signal<void, bool, int> MapStorage::signal_prop_ch()
+{
+  return signal_prop;
+}
+
+int MapStorage::addEdgeMap(const std::string & name, Graph::EdgeMap<double> *edgemap, double default_value)
+{
+  if( edgemap_storage.find(name) == edgemap_storage.end() )
+    {
+      edgemap_storage[name]=edgemap;
+      // set the maps default value
+      edgemap_default[name] = default_value;
+
+      //announce changement in maps
+      signal_edge_map.emit(name);
+      return 0;
+    }
+  return 1;
+}
+
+double MapStorage::maxOfNodeMap(const std::string & name)
+{
+  double max=0;
+  for (NodeIt j(graph); j!=INVALID; ++j)
+  {
+    if( (*nodemap_storage[name])[j]>max )
+    {
+      max=(*nodemap_storage[name])[j];
+    }
+  }
+  return max;
+}
+
+double MapStorage::maxOfEdgeMap(const std::string & name)
+{
+  double max=0;
+  for (EdgeIt j(graph); j!=INVALID; ++j)
+  {
+    if( (*edgemap_storage[name])[j]>max )
+    {
+      max=(*edgemap_storage[name])[j];
+    }
+  }
+  return max;
+}
+
+double MapStorage::minOfNodeMap(const std::string & name)
+{
+  NodeIt j(graph);
+  double min;
+  if(j!=INVALID)
+    {
+      min=(*nodemap_storage[name])[j];
+    }
   else
-  {
-    std::vector<std::string> ret;
-    for (EdgeMapStore::const_iterator it = edgemaps.begin();
-        it != edgemaps.end(); ++it)
-    {
-      EdgeMapData* data = getEdgeMapData(it->first);
-      MapValue::Type t = data->type();
-      if ((t == MapValue::NUMERIC && (type & NUM)) ||
-          (t == MapValue::STRING && (type & STR)))
-      {
-        ret.push_back(it->first);
-      }
-    }
-    return ret;
-  }
-}
-
-std::vector<std::string> MapStorage::getNodeMapList(MapType type)
-{
-  if (type == ALL)
-  {
-    std::vector<std::string> ret;
-    for (NodeMapStore::const_iterator it = nodemaps.begin();
-        it != nodemaps.end(); ++it)
-    {
-      ret.push_back(it->first);
-    }
-    return ret;
-  }
+    {
+      min=0;
+    }
+  for (; j!=INVALID; ++j)
+  {
+    if( (*nodemap_storage[name])[j]<min )
+    {
+      min=(*nodemap_storage[name])[j];
+    }
+  }
+  return min;
+}
+
+double MapStorage::minOfEdgeMap(const std::string & name)
+{
+  EdgeIt j(graph);
+  double min;
+  if(j!=INVALID)
+    {
+      min=(*edgemap_storage[name])[j];
+    }
   else
-  {
-    std::vector<std::string> ret;
-    for (NodeMapStore::const_iterator it = nodemaps.begin();
-        it != nodemaps.end(); ++it)
-    {
-      NodeMapData* data = getNodeMapData(it->first);
-      MapValue::Type t = data->type();
-      if ((t == MapValue::NUMERIC && (type & NUM)) ||
-          (t == MapValue::STRING && (type & STR)))
-      {
-        ret.push_back(it->first);
-      }
-    }
-    return ret;
-  }
-}
-
-sigc::signal<void, bool, int> MapStorage::signal_prop_ch()
-{
-  return signal_prop;
+    {
+      min=0;
+    }
+  for (EdgeIt j(graph); j!=INVALID; ++j)
+  {
+    if( (*edgemap_storage[name])[j]<min )
+    {
+      min=(*edgemap_storage[name])[j];
+    }
+  }
+  return min;
 }
 
 int MapStorage::readFromFile(const std::string &filename)
 {
-  using std::vector;
-  using std::map;
-  using std::string;
-
-  // check whether the .conf file exists
-  bool gui_data_in_conf = g_file_test((filename + ".conf").c_str(),
-      (GFileTest)(G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR));
-
-  // check whether the .lgf file contains a gui section
-  bool gui_data_in_lgf = false;
-  {
-    std::ifstream ifs(filename.c_str());
-    std::string line;
-    while (getline(ifs, line))
-    {
-      int pos = line.find("@gui");
-      if (pos != std::string::npos)
-      {
-        bool only_whitespace_before = true;
-        for (int i = 0; i < pos; ++i)
-        {
-          if (!std::isspace(line[i]))
-          {
-            only_whitespace_before = false;
-            break;
-          }
-        }
-        if (only_whitespace_before) gui_data_in_lgf = true;
-      }
-    }
-  }
-
-  bool gui_data_found = gui_data_in_lgf || gui_data_in_conf;
-
-  // ask for user input if both exist
-  bool use_gui_data_in_lgf = false;
-  if (gui_data_in_conf && gui_data_in_lgf)
-  {
-    Gtk::MessageDialog mdialog(_("<b>Found both ") + filename +
-        _(".conf and a gui section in ") + filename + _(".</b>"), true,
-        Gtk::MESSAGE_QUESTION, Gtk::BUTTONS_NONE);
-	  mdialog.add_button(_("Use the ._conf file"), 1);
-	  mdialog.add_button(_("Use the _gui section"), 2);
-    switch (mdialog.run())
-    {
-      case 1:
-        use_gui_data_in_lgf = false;
-        break;
-      case 2:
-        use_gui_data_in_lgf = true;
-        break;
-      case Gtk::RESPONSE_NONE:
-        return 1;
-    }
-  }
-  else
-  {
-    use_gui_data_in_lgf = gui_data_in_lgf;
-  }
-
-  if (gui_data_found)
-  {
-    GUISectData gui_data;
-    if (use_gui_data_in_lgf)
-    {
-      // read the gui section from the .lgf file
-      try
-      {
-        LemonReader lreader(filename);
-        GuiReader gui_reader(lreader, this, gui_data);
-        lreader.run();
-        gui_sect_save_dest = LGF_FILE;
-      }
-      catch (Exception& error)
-      {
-        clear();
-        return 1;
-      }
-    }
-    else
-    {
-      // read the gui section from the .conf file
-      try
-      {
-        LemonReader lreader(filename + ".conf");
-        GuiReader gui_reader(lreader, this, gui_data);
-        lreader.run();
-        gui_sect_save_dest = CONF_FILE;
-      }
-      catch (Exception& error)
-      {
-        clear();
-        return 1;
-      }
-    }
-
-    // read the graph and maps form the .lgf file
-    try
-    {
-      std::string node_coord_xmap_name, node_coord_ymap_name;
-      std::string arrow_coord_xmap_name, arrow_coord_ymap_name;
-
-      if (gui_data.node_coords_save_dest ==
-          MapStorage::SpecMapSaveOpts::NESET_SECT)
-      {
-        switch (gui_data.node_coords_save_map_num)
-        {
-          case SpecMapSaveOpts::ONE_MAP:
-            node_coord_xmap_name = gui_data.node_coords_one_map_name + ":x";
-            node_coord_ymap_name = gui_data.node_coords_one_map_name + ":y";
-            node_coords_one_map_name = gui_data.node_coords_one_map_name;
-            break;
-          case SpecMapSaveOpts::TWO_MAPS:
-            node_coord_xmap_name = gui_data.node_coords_two_maps_1_name;
-            node_coord_ymap_name = gui_data.node_coords_two_maps_2_name;
-            node_coords_two_maps_1_name = gui_data.node_coords_two_maps_1_name;
-            node_coords_two_maps_2_name = gui_data.node_coords_two_maps_2_name;
-            break;
-        }
-        node_coords_save_dest = gui_data.node_coords_save_dest;
-        node_coords_save_map_num = gui_data.node_coords_save_map_num;
-      }
-
-      if (gui_data.arrow_coords_save_dest ==
-          MapStorage::SpecMapSaveOpts::NESET_SECT)
-      {
-        switch (gui_data.arrow_coords_save_map_num)
-        {
-          case SpecMapSaveOpts::ONE_MAP:
-            arrow_coord_xmap_name = gui_data.arrow_coords_one_map_name + ":x";
-            arrow_coord_ymap_name = gui_data.arrow_coords_one_map_name + ":y";
-            arrow_coords_one_map_name = gui_data.arrow_coords_one_map_name;
-            break;
-          case SpecMapSaveOpts::TWO_MAPS:
-            arrow_coord_xmap_name = gui_data.arrow_coords_two_maps_1_name;
-            arrow_coord_ymap_name = gui_data.arrow_coords_two_maps_2_name;
-            arrow_coords_two_maps_1_name =
-              gui_data.arrow_coords_two_maps_1_name;
-            arrow_coords_two_maps_2_name =
-              gui_data.arrow_coords_two_maps_2_name;
-            break;
-        }
-        arrow_coords_save_dest = gui_data.arrow_coords_save_dest;
-        arrow_coords_save_map_num = gui_data.arrow_coords_save_map_num;
-      }
-      readLGF(filename, true,
-          gui_data.main_node_map_names, gui_data.main_edge_map_names,
-          gui_data.node_map_types, gui_data.edge_map_types,
-          node_coord_xmap_name, node_coord_ymap_name,
-          arrow_coord_xmap_name, arrow_coord_ymap_name);
-    }
-    catch (Exception& error)
-    {
+  bool read_x = false;
+  bool read_y = false;
+  bool read_edge_id = false;
+
+  try {
+    LemonReader lreader(filename);
+    ContentReader content(lreader);
+    lreader.run();
+
+    if (content.nodeSetNum() < 1)
+    {
+      Gtk::MessageDialog mdialog("No nodeset found in file.");
+      mdialog.run();
       clear();
       return 1;
     }
 
-    // add the maps from the gui section
-    for (vector<string>::const_iterator
-        it = gui_data.gui_node_map_names.begin();
-        it != gui_data.gui_node_map_names.end(); ++it)
-    {
-      string map_name = *it;
-      switch (gui_data.node_map_types[map_name])
-      {
-        case MapValue::NUMERIC:
-          {
-            createNodeMap(map_name, MapValue::NUMERIC, double());
-            NumericNodeMap& dmap = getNumericNodeMap(map_name);
-            map<int, double>& smap = *gui_data.numeric_node_maps[map_name];
-            for (NodeIt n(graph); n != INVALID; ++n)
-            {
-              dmap[n] = smap[node_label[n]];
-            }
-            break;
-          }
-        case MapValue::STRING:
-          {
-            createNodeMap(map_name, MapValue::STRING, string());
-            StringNodeMap& dmap = getStringNodeMap(map_name);
-            map<int, string>& smap = *gui_data.string_node_maps[map_name];
-            for (NodeIt n(graph); n != INVALID; ++n)
-            {
-              dmap[n] = smap[node_label[n]];
-            }
-            break;
-          }
-      }
-      getNodeMapData(map_name)->save_dest = GUI_SECT;
-    }
-    for (vector<string>::const_iterator
-        it = gui_data.gui_edge_map_names.begin();
-        it != gui_data.gui_edge_map_names.end(); ++it)
-    {
-      string map_name = *it;
-      switch (gui_data.edge_map_types[map_name])
-      {
-        case MapValue::NUMERIC:
-          {
-            createEdgeMap(map_name, MapValue::NUMERIC, double());
-            NumericEdgeMap& dmap = getNumericEdgeMap(map_name);
-            map<int, double>& smap = *gui_data.numeric_edge_maps[map_name];
-            for (EdgeIt e(graph); e != INVALID; ++e)
-            {
-              dmap[e] = smap[edge_label[e]];
-            }
-            break;
-          }
-        case MapValue::STRING:
-          {
-            createEdgeMap(map_name, MapValue::STRING, string());
-            StringEdgeMap& dmap = getStringEdgeMap(map_name);
-            map<int, string>& smap = *gui_data.string_edge_maps[map_name];
-            for (EdgeIt e(graph); e != INVALID; ++e)
-            {
-              dmap[e] = smap[edge_label[e]];
-            }
-            break;
-          }
-      }
-      getEdgeMapData(map_name)->save_dest = GUI_SECT;
-    }
-
-    // restore the node coordinate maps
-    if (gui_data.node_coords_save_dest ==
-        MapStorage::SpecMapSaveOpts::GUI_SECT)
-    {
-      for (NodeIt n(graph); n != INVALID; ++n)
-      {
-        node_coords.set(n, gui_data.node_coord_map[node_label[n]]);
-      }
-      node_coords_save_dest = gui_data.node_coords_save_dest;
-    }
-    // restore the arrow coordinate maps
-    if (gui_data.arrow_coords_save_dest ==
-        MapStorage::SpecMapSaveOpts::GUI_SECT)
-    {
+    if (content.edgeSetNum() < 1)
+    {
+      Gtk::MessageDialog mdialog("No edgeset found in file.");
+      mdialog.run();
+      clear();
+      return 1;
+    }
+
+    const std::vector<std::string>& nodeMapNames = content.nodeSetMaps(0);
+    const std::vector<std::string>& edgeMapNames = content.edgeSetMaps(0);
+
+    GraphReader<Graph> greader(filename, graph);
+    for (std::vector<std::string>::const_iterator it = nodeMapNames.begin();
+        it != nodeMapNames.end(); ++it)
+    {
+      if (*it == "coordinates_x")
+      {
+        read_x = true;
+        //std::cout << "read X nodemap" << std::endl;
+      }
+      else if (*it == "coordinates_y")
+      {
+        read_y = true;
+        //std::cout << "read Y nodemap" << std::endl;
+      }
+      else if (*it == "label")
+      {
+        //std::cout << "read id nodemap" << std::endl;
+      }
+      else
+      {
+        nodemap_storage[*it] = new Graph::NodeMap<double>(graph);
+        //std::cout << "read " << *it << " nodemap" << std::endl;
+      }
+      greader.readNodeMap(*it, *nodemap_storage[*it]);
+    }
+    for (std::vector<std::string>::const_iterator it = edgeMapNames.begin();
+        it != edgeMapNames.end(); ++it)
+    {
+      if (*it == "label")
+      {
+        //std::cout << "read id edgemap" << std::endl;
+        read_edge_id = true;
+      }
+      else
+      {
+        edgemap_storage[*it] = new Graph::EdgeMap<double>(graph);
+        //std::cout << "read " << *it << " edgemap" << std::endl;
+      }
+      greader.readEdgeMap(*it, *edgemap_storage[*it]);
+    }
+    GuiReader gui_reader(greader, this);
+    greader.run();
+  } catch (Exception& error) {
+    Gtk::MessageDialog mdialog(error.what());
+    mdialog.run();
+    clear();
+    return 1;
+  }
+
+  if (!read_edge_id)
+  {
+    edgemap_storage["label"] = new Graph::EdgeMap<double>(graph);
+    int i = 1;
+    for (EdgeIt e(graph); e != INVALID; ++e)
+    {
+      (*edgemap_storage["label"])[e] = i++;
+    }
+  }
+
+  if (!read_x || !read_y)
+  {
+    int node_num = 0;
+    for (NodeIt n(graph); n != INVALID; ++n)
+    {
+      node_num++;
+    }
+    const double pi = 3.142;
+    double step = 2 * pi / (double) node_num;
+    int i = 0;
+    for (NodeIt n(graph); n != INVALID; ++n)
+    {
+      nodemap_storage["coordinates_x"]->set(n, 250.0 * std::cos(i * step));
+      nodemap_storage["coordinates_y"]->set(n, 250.0 * std::sin(i * step));
+      i++;
+    }
+  }
+
+  if (!arrow_pos_read_ok)
+  {
+    arrow_pos_read_ok = false;
+    for (EdgeIt e(graph); e != INVALID; ++e)
+    {
+      if (graph.source(e) == graph.target(e))
+      {
+        arrow_pos.set(e, coords[graph.source(e)] + XY(0.0, 80.0));
+      }
+      else
+      {
+        arrow_pos.set(e, (coords[graph.source(e)] + coords[graph.target(e)]) / 2.0);
+      }
+    }
+  }
+
+  // fill in the default values for the maps
+  for (std::map<std::string, Graph::NodeMap<double>*>::const_iterator it =
+      nodemap_storage.begin(); it != nodemap_storage.end(); ++it)
+  {
+    if ((it->first != "label") &&
+        (it->first != "coordiantes_x") &&
+        (it->first != "coordinates_y"))
+    {
+      nodemap_default[it->first] = 0.0;
+    }
+    else if (it->first == "label")
+    {
+      NodeIt n(graph);
+      double max = (*nodemap_storage["label"])[n];
+      for (; n != INVALID; ++n)
+      {
+        if ((*nodemap_storage["label"])[n] > max)
+          max = (*nodemap_storage["label"])[n];
+      }
+      nodemap_default["label"] = max + 1.0;
+    }
+  }
+  for (std::map<std::string, Graph::EdgeMap<double>*>::const_iterator it =
+      edgemap_storage.begin(); it != edgemap_storage.end(); ++it)
+  {
+    if (it->first != "label")
+    {
+      edgemap_default[it->first] = 0.0;
+    }
+    else
+    {
+      double max = std::numeric_limits<double>::min();
       for (EdgeIt e(graph); e != INVALID; ++e)
       {
-        arrow_coords.set(e, gui_data.arrow_coord_map[edge_label[e]]);
-      }
-      arrow_coords_save_dest = gui_data.arrow_coords_save_dest;
-    }
-  }
-  else
-  {
-    // there is no gui section neither in the .lgf file nor in the .conf file
-    {
-      LemonReader lreader(filename);
-      ContentReader content(lreader);
-      try
-      {
-        lreader.run();
-      }
-      catch (Exception& error)
-      {
-        Gtk::MessageDialog mdialog(error.what());
-        mdialog.run();
-        clear();
-        return 1;
-      }
-
-      if (content.nodeSetNum() < 1)
-      {
-        Gtk::MessageDialog mdialog("No nodeset found in file.");
-        mdialog.run();
-        clear();
-        return 1;
-      }
-
-      if (content.edgeSetNum() < 1)
-      {
-        Gtk::MessageDialog mdialog("No edgeset found in file.");
-        mdialog.run();
-        clear();
-        return 1;
-      }
-
-      std::vector<std::string> nodeMapNames = content.nodeSetMaps(0);
-      std::vector<std::string> edgeMapNames = content.edgeSetMaps(0);
-      
-      bool read_edge_label = true;
-      if (std::find(edgeMapNames.begin(), edgeMapNames.end(), "label") ==
-          edgeMapNames.end())
-      {
-        read_edge_label = false;
-      }
-
-      nodeMapNames.erase(
-          std::remove(nodeMapNames.begin(), nodeMapNames.end(), "label"),
-          nodeMapNames.end());
-
-      edgeMapNames.erase(
-          std::remove(edgeMapNames.begin(), edgeMapNames.end(), "label"),
-          edgeMapNames.end());
-
-      FileImportDialog::ImportData data(nodeMapNames, edgeMapNames);
-      FileImportDialog fidialog(&data);
-      int response = fidialog.run();
-      if (response == Gtk::RESPONSE_OK)
-      {
-        try
-        {
-          std::string node_coord_xmap_name, node_coord_ymap_name;
-          std::string arrow_coord_xmap_name, arrow_coord_ymap_name;
-          bool gen_node_coords = false;
-          bool gen_arrow_coords = false;
-
-          switch (data.node_coord_load_from)
-          {
-            case FileImportDialog::ImportData::ONE_MAP:
-              node_coord_xmap_name = data.node_coord_one_map_name + ":x";
-              node_coord_ymap_name = data.node_coord_one_map_name + ":y";
-              node_coords_one_map_name = data.node_coord_one_map_name;
-
-              node_coords_save_dest = SpecMapSaveOpts::NESET_SECT;
-              node_coords_save_map_num = SpecMapSaveOpts::ONE_MAP;
-              break;
-            case FileImportDialog::ImportData::TWO_MAPS:
-              node_coord_xmap_name = data.node_coord_two_maps_1_name;
-              node_coord_ymap_name = data.node_coord_two_maps_2_name;
-              node_coords_two_maps_1_name = data.node_coord_two_maps_1_name;
-              node_coords_two_maps_2_name = data.node_coord_two_maps_2_name;
-
-              node_coords_save_dest = SpecMapSaveOpts::NESET_SECT;
-              node_coords_save_map_num = SpecMapSaveOpts::TWO_MAPS;
-              break;
-            case FileImportDialog::ImportData::DONT_READ:
-              node_coord_xmap_name = "";
-              node_coord_ymap_name = "";
-
-              node_coords_save_dest = SpecMapSaveOpts::GUI_SECT;
-              gen_node_coords = true;
-              break;
-          }
-
-          switch (data.arrow_coord_load_from)
-          {
-            case FileImportDialog::ImportData::ONE_MAP:
-              arrow_coord_xmap_name = data.arrow_coord_one_map_name + ":x";
-              arrow_coord_ymap_name = data.arrow_coord_one_map_name + ":y";
-              arrow_coords_one_map_name = data.arrow_coord_one_map_name;
-
-              arrow_coords_save_dest = SpecMapSaveOpts::NESET_SECT;
-              arrow_coords_save_map_num = SpecMapSaveOpts::ONE_MAP;
-              break;
-            case FileImportDialog::ImportData::TWO_MAPS:
-              arrow_coord_xmap_name = data.arrow_coord_two_maps_1_name;
-              arrow_coord_ymap_name = data.arrow_coord_two_maps_2_name;
-              arrow_coords_two_maps_1_name = data.arrow_coord_two_maps_1_name;
-              arrow_coords_two_maps_2_name = data.arrow_coord_two_maps_2_name;
-
-              arrow_coords_save_dest = SpecMapSaveOpts::NESET_SECT;
-              arrow_coords_save_map_num = SpecMapSaveOpts::TWO_MAPS;
-              break;
-            case FileImportDialog::ImportData::DONT_READ:
-              arrow_coord_xmap_name = "";
-              arrow_coord_ymap_name = "";
-
-              arrow_coords_save_dest = SpecMapSaveOpts::GUI_SECT;
-              gen_arrow_coords = true;
-              break;
-          }
-
-          // read edge and node maps
-          std::vector<std::string> node_map_names;
-          std::vector<std::string> edge_map_names;
-          std::map<std::string, MapValue::Type> node_map_types;
-          std::map<std::string, MapValue::Type> edge_map_types;
-          for (std::vector<std::string>::const_iterator it =
-              data.numeric_node_map_names.begin();
-              it != data.numeric_node_map_names.end(); ++it)
-          {
-            node_map_names.push_back(*it);
-            node_map_types[*it] = MapValue::NUMERIC;
-          }
-          for (std::vector<std::string>::const_iterator it =
-              data.string_node_map_names.begin();
-              it != data.string_node_map_names.end(); ++it)
-          {
-            node_map_names.push_back(*it);
-            node_map_types[*it] = MapValue::STRING;
-          }
-          for (std::vector<std::string>::const_iterator it =
-              data.numeric_edge_map_names.begin();
-              it != data.numeric_edge_map_names.end(); ++it)
-          {
-            edge_map_names.push_back(*it);
-            edge_map_types[*it] = MapValue::NUMERIC;
-          }
-          for (std::vector<std::string>::const_iterator it =
-              data.string_edge_map_names.begin();
-              it != data.string_edge_map_names.end(); ++it)
-          {
-            edge_map_names.push_back(*it);
-            edge_map_types[*it] = MapValue::STRING;
-          }
-
-          readLGF(filename, read_edge_label,
-              node_map_names, edge_map_names,
-              node_map_types, edge_map_types,
-              node_coord_xmap_name, node_coord_ymap_name,
-              arrow_coord_xmap_name, arrow_coord_ymap_name);
-
-          // generate edge labels
-          if (!read_edge_label)
-          {
-            int l = 0;
-            for (EdgeIt e(graph); e != INVALID; ++e)
-            {
-              edge_label[e] = l++;
-            }
-          }
-
-          if (gen_node_coords)
-          {
-            // generate node coordinates
-            int node_num = 0;
-            for (NodeIt n(graph); n != INVALID; ++n) { node_num++; }
-            const double pi = 3.142;
-            double step = 2 * pi / (double) node_num;
-            int i = 0;
-            for (NodeIt n(graph); n != INVALID; ++n)
-            {
-              setNodeCoords(n,
-                  XY(250.0 * std::cos(i * step),
-                    250.0 * std::sin(i * step)));
-              i++;
-            }
-          }
-          if (gen_arrow_coords)
-          {
-            // generate arrow coordinates
-            for (EdgeIt e(graph); e != INVALID; ++e)
-            {
-              if (graph.source(e) == graph.target(e))
-              {
-                setArrowCoords(e,
-                    getNodeCoords(graph.source(e)) + XY(0.0, 80.0));
-              }
-              else
-              {
-                setArrowCoords(e,
-                    (getNodeCoords(graph.source(e)) +
-                     getNodeCoords(graph.target(e))) / 2.0);
-              }
-            }
-          }
-        }
-        catch (Exception& error)
-        {
-          clear();
-          return 1;
-        }
-      }
+        if ((*edgemap_storage["label"])[e] > max)
+          max = (*edgemap_storage["label"])[e];
+      }
+      if (max > std::numeric_limits<double>::min())
+        edgemap_default["label"] = max + 1.0;
       else
-      {
-        clear();
-        return 1;
-      }
-    }
-  }
-
-  // set max_node_label
-  {
-    max_node_label = std::numeric_limits<int>::min();
-    for (NodeIt n(graph); n != INVALID; ++n)
-    {
-      if (node_label[n] > max_node_label)
-      {
-        max_node_label = node_label[n];
-      }
-    }
-  }
-  // set max_edge_label
-  {
-    max_edge_label = std::numeric_limits<int>::min();
-    for (EdgeIt e(graph); e != INVALID; ++e)
-    {
-      if (edge_label[e] > max_edge_label)
-      {
-        max_edge_label = edge_label[e];
-      }
+        edgemap_default["label"] = 1.0;
     }
   }
